window.Gleam.initSearch([{"doc":"webls","title":"webls","content":"# WebLS\n\nA Gleam library for generating sitemaps and RSS feeds and more. to meet all\nyour common web listing needs.\n\n[![Package Version](https://img.shields.io/hexpm/v/webls)](https://hex.pm/packages/webls)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/webls/)\n\n```sh\ngleam add webls@1\n```\n\n```gleam\nimport webls/rss.{RssChannel, RssItem}\n\npub fn generate_rss_feed() -&gt; String {\n  let channels = [\n    RssChannel(\n      title: &quot;Gleam RSS&quot;,\n      description: &quot;A test RSS feed&quot;,\n      link: &quot;https://gleam.run&quot;,\n      items: [\n        RssItem(\n          title: &quot;Gleam 1.0&quot;,\n          link: &quot;https://gleam.run/blog/gleam-1.0&quot;,\n          description: &quot;Gleam 1.0 is here!&quot;,\n          pub_date: birl.now(),\n          author: None,\n          guid: #(&quot;gleam.run&quot;, Some(True)),\n        ),\n        RssItem(\n          title: &quot;Gleam 0.10&quot;,\n          link: &quot;https://gleam.run/blog/gleam-0.10&quot;,\n          description: &quot;Gleam 0.10 is here!&quot;,\n          pub_date: birl.now(),\n          author: Some(&quot;ve.re.ca@protonmail.com&quot;),\n          guid: #(&quot;gleam.run&quot;, Some(True)),\n        ),\n      ],\n    ),\n  ]\n\n  channels\n  |&gt; rss.to_string()\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/webls&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\n```\n\n&gt; Yes the name is a reference to the `ls` command in unix to list files\n","url":"index.html"},{"doc":"webls/robots","title":"Robot","content":"pub type Robot {\n  Robot(\n    user_agent: String,\n    allowed_routes: List(String),\n    disallowed_routes: List(String),\n  )\n}\n The policy for a specific robot\nRobot(\n  user_agent: String,\n  allowed_routes: List(String),\n  disallowed_routes: List(String),\n)\n\nuser_agent\n&lt;p&gt;The user agent such as “googlebot” or “*” for catch all&lt;/p&gt;\n\nallowed_routes\n&lt;p&gt;The allowed routes such as “/posts/” and “/contact/”&lt;/p&gt;\n\ndisallowed_routes\n&lt;p&gt;The disallowed routes such as “/admin/” and “/private/”&lt;/p&gt;\n\nSynonyms:\nwebls/robots.Robot\nwebls/robots Robot","url":"webls/robots.html#Robot"},{"doc":"webls/robots","title":"RobotsConfig","content":"pub type RobotsConfig {\n  RobotsConfig(sitemap_url: String, robots: List(Robot))\n}\n The configuration for a robots.txt file\nRobotsConfig(sitemap_url: String, robots: List(Robot))\n\nsitemap_url\n&lt;p&gt;The url of the sitemap for crawlers to use&lt;/p&gt;\n\nrobots\n&lt;p&gt;A list of robot policies&lt;/p&gt;\n\nSynonyms:\nwebls/robots.RobotsConfig\nwebls/robots RobotsConfig","url":"webls/robots.html#RobotsConfig"},{"doc":"webls/robots","title":"to_string","content":"pub fn to_string(config: RobotsConfig) -&gt; String\n\nSynonyms:\nwebls/robots.to_string\nwebls/robots to_string","url":"webls/robots.html#to_string"},{"doc":"webls/robots","title":"webls/robots","content":"","url":"webls/robots.html"},{"doc":"webls/rss","title":"RssChannel","content":"pub type RssChannel {\n  RssChannel(\n    title: String,\n    description: String,\n    link: String,\n    items: List(RssItem),\n  )\n}\n A simple RSS channel\nRssChannel(\n  title: String,\n  description: String,\n  link: String,\n  items: List(RssItem),\n)\n\ntitle\n&lt;p&gt;The title of the RSS channel&lt;/p&gt;\n\ndescription\n&lt;p&gt;The description of the RSS channel&lt;/p&gt;\n\nlink\n&lt;p&gt;The link to the top page of the RSS channel&lt;/p&gt;\n\nitems\n&lt;p&gt;The list of items in the RSS channel&lt;/p&gt;\n\nSynonyms:\nwebls/rss.RssChannel\nwebls/rss RssChannel","url":"webls/rss.html#RssChannel"},{"doc":"webls/rss","title":"RssItem","content":"pub type RssItem {\n  RssItem(\n    title: String,\n    link: String,\n    description: String,\n    pub_date: Time,\n    author: Option(String),\n    guid: #(String, Option(Bool)),\n  )\n}\n A simple RSS item with optional author\nRssItem(\n  title: String,\n  link: String,\n  description: String,\n  pub_date: Time,\n  author: Option(String),\n  guid: #(String, Option(Bool)),\n)\n\ntitle\n&lt;p&gt;The title of the RSS item&lt;/p&gt;\n\nlink\n&lt;p&gt;The link to the page the RSS item is on&lt;/p&gt;\n\ndescription\n&lt;p&gt;The description of the RSS item&lt;/p&gt;\n\npub_date\n&lt;p&gt;The publication date of the RSS item&lt;/p&gt;\n\nauthor\n&lt;p&gt;An optional author field, note RSS author must be email addresses&lt;/p&gt;\n\nguid\n&lt;p&gt;A guid and an optional boolean for whether it is a permalink&lt;/p&gt;\n\nSynonyms:\nwebls/rss.RssItem\nwebls/rss RssItem","url":"webls/rss.html#RssItem"},{"doc":"webls/rss","title":"to_string","content":"pub fn to_string(channels: List(RssChannel)) -&gt; String\n Generates an RSS feed as a string from a list of channels\nSynonyms:\nwebls/rss.to_string\nwebls/rss to_string","url":"webls/rss.html#to_string"},{"doc":"webls/rss","title":"webls/rss","content":"","url":"webls/rss.html"},{"doc":"webls/sitemap","title":"ChangeFrequency","content":"pub type ChangeFrequency {\n  Always\n  Hourly\n  Daily\n  Weekly\n  Monthly\n  Yearly\n  Never\n}\n The fequency at which a page tends to change\nAlways\n\n\nHourly\n\n\nDaily\n\n\nWeekly\n\n\nMonthly\n\n\nYearly\n\n\nNever\n\n\nSynonyms:\nwebls/sitemap.ChangeFrequency\nwebls/sitemap ChangeFrequency","url":"webls/sitemap.html#ChangeFrequency"},{"doc":"webls/sitemap","title":"Sitemap","content":"pub type Sitemap {\n  Sitemap(\n    url: String,\n    last_modified: Option(Time),\n    items: List(SitemapItem),\n  )\n}\n A complete sitemap\nSitemap(\n  url: String,\n  last_modified: Option(Time),\n  items: List(SitemapItem),\n)\n\nurl\n&lt;p&gt;The url location of the sitemap&lt;/p&gt;\n\nlast_modified\n&lt;p&gt;The time of last modification of the sitemap&lt;/p&gt;\n\nitems\n&lt;p&gt;The list of items contained within the sitemap&lt;/p&gt;\n\nSynonyms:\nwebls/sitemap.Sitemap\nwebls/sitemap Sitemap","url":"webls/sitemap.html#Sitemap"},{"doc":"webls/sitemap","title":"SitemapItem","content":"pub type SitemapItem {\n  SitemapItem(\n    loc: String,\n    last_modified: Option(Time),\n    change_frequency: Option(ChangeFrequency),\n    priority: Option(Float),\n  )\n}\n A item within a sitemap\nSitemapItem(\n  loc: String,\n  last_modified: Option(Time),\n  change_frequency: Option(ChangeFrequency),\n  priority: Option(Float),\n)\n\nloc\n&lt;p&gt;The location/url of the page&lt;/p&gt;\n\nlast_modified\n&lt;p&gt;The time of last modification of the page&lt;/p&gt;\n\nchange_frequency\n&lt;p&gt;How frequently the page is likely to continue to change&lt;/p&gt;\n\npriority\n&lt;p&gt;The priority of the page compared to others within the sitemap\nMust be between 0.0 and 1.0&lt;/p&gt;\n\nSynonyms:\nwebls/sitemap.SitemapItem\nwebls/sitemap SitemapItem","url":"webls/sitemap.html#SitemapItem"},{"doc":"webls/sitemap","title":"to_string","content":"pub fn to_string(sitemap: Sitemap) -&gt; String\n Generates a sitemap.xml string from a sitemap\nSynonyms:\nwebls/sitemap.to_string\nwebls/sitemap to_string","url":"webls/sitemap.html#to_string"},{"doc":"webls/sitemap","title":"webls/sitemap","content":"","url":"webls/sitemap.html"}]);